using System;
using System.IO;
using System.Collections;

namespace Snake
{
	public class Highscores
	{
		private static ArrayList playerList = new ArrayList();

		public static Player[] GetHighscoreList()
		{
			string line;
			playerList.Clear();

			StreamReader reader = new StreamReader("scores.dat");

			while((line = reader.ReadLine()) != null)
			{
				Player player = new Player();
				player.Name = line.Split('|')[0];
				player.Score = Convert.ToInt64(line.Split('|')[1]);
				playerList.Add(player);
				if(playerList.Count >= 10) break;
			}

			playerList.Sort(null);
			reader.Close();
			return (Player[]) playerList.ToArray(typeof(Player));
		}

		public static void SaveHighscore(string name, long points)
		{
			Player player = new Player();
			player.Name = name;
			player.Score = points;
			playerList.Add(player);
			playerList.Sort(null);
			if(playerList.Count > 10)
			{
				playerList.RemoveAt(playerList.Count - 1);
			}

			StreamWriter sWriter = new StreamWriter("scores.dat", false);

			foreach(Player pl in playerList)
			{
				sWriter.WriteLine(pl.Name + "|" + pl.Score.ToString());
			}

			sWriter.Close();
		}

		public static bool IsHighScore(long score)
		{
			if(((Player)playerList[playerList.Count - 1]).Score < score)
			{
				return true;
			}

			return false;
		}
	}

	public struct Player : IComparable
	{
		public string Name;
		public long Score;

		public int CompareTo(object o)
		{
			Player player = (Player)o;

			if(this.Score > player.Score)
			{
				return -1;
			}
			else if(this.Score < player.Score)
			{
				return 1;
			}
			else
			{
				return 0;
			}
		}
	}
}