using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Snake
{
	/// <summary>
	/// Zusammendfassende Beschreibung fr frmMain.
	/// </summary>
	public class frmMain : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button cmdNewGame;
		private System.Windows.Forms.Button cmdInfo;
		private System.Windows.Forms.Button cmdExit;
		private System.Windows.Forms.Button cmdPass;
		private System.Windows.Forms.Button cmdHighScore;

		private System.ComponentModel.Container components = null;

		public frmMain()
		{
			InitializeComponent();
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdNewGame = new System.Windows.Forms.Button();
			this.cmdInfo = new System.Windows.Forms.Button();
			this.cmdExit = new System.Windows.Forms.Button();
			this.cmdPass = new System.Windows.Forms.Button();
			this.cmdHighScore = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cmdNewGame
			// 
			this.cmdNewGame.Location = new System.Drawing.Point(84, 44);
			this.cmdNewGame.Name = "cmdNewGame";
			this.cmdNewGame.TabIndex = 0;
			this.cmdNewGame.Text = "New Game";
			this.cmdNewGame.Click += new System.EventHandler(this.cmdNewGame_Click);
			// 
			// cmdInfo
			// 
			this.cmdInfo.Location = new System.Drawing.Point(84, 140);
			this.cmdInfo.Name = "cmdInfo";
			this.cmdInfo.TabIndex = 3;
			this.cmdInfo.Text = "Info";
			this.cmdInfo.Click += new System.EventHandler(this.cmdInfo_Click);
			// 
			// cmdExit
			// 
			this.cmdExit.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdExit.Location = new System.Drawing.Point(84, 172);
			this.cmdExit.Name = "cmdExit";
			this.cmdExit.TabIndex = 4;
			this.cmdExit.Text = "Exit";
			this.cmdExit.Click += new System.EventHandler(this.cmdExit_Click);
			// 
			// cmdPass
			// 
			this.cmdPass.Location = new System.Drawing.Point(84, 76);
			this.cmdPass.Name = "cmdPass";
			this.cmdPass.TabIndex = 1;
			this.cmdPass.Text = "Enter Pass";
			this.cmdPass.Click += new System.EventHandler(this.cmdPass_Click);
			// 
			// cmdHighScore
			// 
			this.cmdHighScore.Location = new System.Drawing.Point(84, 108);
			this.cmdHighScore.Name = "cmdHighScore";
			this.cmdHighScore.TabIndex = 2;
			this.cmdHighScore.Text = "Highscores";
			this.cmdHighScore.Click += new System.EventHandler(this.cmdHighScore_Click);
			// 
			// frmMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdExit;
			this.ClientSize = new System.Drawing.Size(242, 239);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdHighScore,
																		  this.cmdPass,
																		  this.cmdExit,
																		  this.cmdInfo,
																		  this.cmdNewGame});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Name = "frmMain";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Snake";
			this.Load += new System.EventHandler(this.frmMain_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmMain());
		}

		private void cmdNewGame_Click(object sender, System.EventArgs e)
		{
			startLevel(1);
		}

		private void cmdExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void cmdInfo_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("Snake  by Alexander 'Ebo1a' Lcking\n\nVersion: " + Application.ProductVersion, "Info", MessageBoxButtons.OK, MessageBoxIcon.Information);
		}

		private void cmdPass_Click(object sender, System.EventArgs e)
		{
			string levelPass = "";
			string inputPass;

			if((inputPass = frmInput.Show("Enter Pass", "Enter password for specific level:")) != null)
			{
				for(int i = 1; ; i++)
				{
					if(File.Exists(i + ".bmp") && File.Exists(i + ".ini"))
					{
						StreamReader reader = new StreamReader(i + ".ini");
						for(int j = 0; j < 7; j++)
						{
							levelPass = reader.ReadLine();
						}
						if(levelPass == inputPass)
						{
							startLevel(i);
							break;
						}
					}
					else
					{
						break;
					}
				}
			}
		}

		private void startLevel(int level)
		{
			frmLevel levelForm = new frmLevel(level);
			levelForm.ShowDialog();
		}

		private void cmdHighScore_Click(object sender, System.EventArgs e)
		{
			frmHighscore highscoreForm = new frmHighscore();
			highscoreForm.ShowDialog();
		}

		private void frmMain_Load(object sender, System.EventArgs e)
		{
			Highscores.GetHighscoreList();
		}
	}
}